<?php
/*
Plugin Name: Count Google Results
Plugin URI: http://aint-no-soul.com/code/2006-06-08/count-google-results/
Description: This Plugin returns the search result *counter* from google. 
Just put a query withing [googlecount][/googlecount] and it will return the current result.
Version: 0.3
Author: [biophonc] Eike Reifhardt
Author URI: http://aint-no-soul.com
*/


function getGoogleResult($query) {
	if(empty($query)) {
		return false;
	}

	$url = "http://www.google.com/search?num=1&q=".trim(urlencode($query));
	$curl = curl_init($url); 
	
	curl_setopt($curl, CURLOPT_HEADER, false);
	curl_setopt($curl, CURLOPT_HTTPGET, true);
	curl_setopt($curl, CURLOPT_POST, false);
	curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
	
	$curl_result = curl_exec($curl); 
	curl_close($curl); 
	
	if (preg_match('/(of about \<b\>([0-9\,]+)\<\/b\>)/', $curl_result, $out)) {
		$res = $out[2];
		return preg_replace('/\,/', '', $res);
	}
}

function countGoogleResults($text) {
	$tag_pattern = '/(\[googlecount\](.*?)\[\/googlecount\])/'; 
	if(preg_match_all($tag_pattern, $text, $out, PREG_SET_ORDER)) {
		foreach($out as $k => $v) {
			$num = getGoogleResult($v[2]);
			$text = str_replace($v[1], $num, $text);
		}
	}
	return $text;
}

add_filter('the_content', 'countGoogleResults');

?>
